(* theory collecting all knowledge 
   (predicates 'is_rootEq_in', 'is_sqrt_in', 'is_ratEq_in')
   for PolynomialEquations.
   alternative dependencies see Isac.thy
   created by: rlang 
         date: 02.07
   changed by: rlang
   last change by: rlang
             date: 03.06.03
   (c) by Richard Lang, 2003
*)

theory PolyEq imports LinEq RootRatEq begin 

consts

(*---------scripts--------------------------*)
  Complete'_square
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Complete'_square (_ _ =))// 
                  (_))" 9)
 (*----- poly ----- *)	 
  Normalize'_poly
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Normalize'_poly (_ _=))// 
                  (_))" 9)
  Solve'_d0'_polyeq'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d0'_polyeq'_equation (_ _ =))// 
                  (_))" 9)
  Solve'_d1'_polyeq'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d1'_polyeq'_equation (_ _ =))// 
                  (_))" 9)
  Solve'_d2'_polyeq'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d2'_polyeq'_equation (_ _ =))// 
                  (_))" 9)
  Solve'_d2'_polyeq'_sqonly'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d2'_polyeq'_sqonly'_equation (_ _ =))// 
                  (_))" 9)
  Solve'_d2'_polyeq'_bdvonly'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d2'_polyeq'_bdvonly'_equation (_ _ =))// 
                  (_))" 9)
  Solve'_d2'_polyeq'_pq'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d2'_polyeq'_pq'_equation (_ _ =))// 
                  (_))" 9)
  Solve'_d2'_polyeq'_abc'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d2'_polyeq'_abc'_equation (_ _ =))// 
                  (_))" 9)
  Solve'_d3'_polyeq'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d3'_polyeq'_equation (_ _ =))// 
                  (_))" 9)
  Solve'_d4'_polyeq'_equation
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Solve'_d4'_polyeq'_equation (_ _ =))// 
                  (_))" 9)
  Biquadrat'_poly
             :: "[bool,real, 
		   bool list] => bool list"
               ("((Script Biquadrat'_poly (_ _=))// 
                  (_))" 9)

(*-------------------- rules -------------------------------------------------*)
axioms 

  cancel_leading_coeff1: "Not (c =!= 0) ==> (a + b*bdv + c*bdv^^^2 = 0) = 
			                   (a/c + b/c*bdv + bdv^^^2 = 0)"
  cancel_leading_coeff2: "Not (c =!= 0) ==> (a - b*bdv + c*bdv^^^2 = 0) = 
			                   (a/c - b/c*bdv + bdv^^^2 = 0)"
  cancel_leading_coeff3: "Not (c =!= 0) ==> (a + b*bdv - c*bdv^^^2 = 0) = 
			                   (a/c + b/c*bdv - bdv^^^2 = 0)"

  cancel_leading_coeff4: "Not (c =!= 0) ==> (a +   bdv + c*bdv^^^2 = 0) = 
			                   (a/c + 1/c*bdv + bdv^^^2 = 0)"
  cancel_leading_coeff5: "Not (c =!= 0) ==> (a -   bdv + c*bdv^^^2 = 0) = 
			                   (a/c - 1/c*bdv + bdv^^^2 = 0)"
  cancel_leading_coeff6: "Not (c =!= 0) ==> (a +   bdv - c*bdv^^^2 = 0) = 
			                   (a/c + 1/c*bdv - bdv^^^2 = 0)"

  cancel_leading_coeff7: "Not (c =!= 0) ==> (    b*bdv + c*bdv^^^2 = 0) = 
			                   (    b/c*bdv + bdv^^^2 = 0)"
  cancel_leading_coeff8: "Not (c =!= 0) ==> (    b*bdv - c*bdv^^^2 = 0) = 
			                   (    b/c*bdv - bdv^^^2 = 0)"

  cancel_leading_coeff9: "Not (c =!= 0) ==> (      bdv + c*bdv^^^2 = 0) = 
			                   (      1/c*bdv + bdv^^^2 = 0)"
  cancel_leading_coeff10:"Not (c =!= 0) ==> (      bdv - c*bdv^^^2 = 0) = 
			                   (      1/c*bdv - bdv^^^2 = 0)"

  cancel_leading_coeff11:"Not (c =!= 0) ==> (a +      b*bdv^^^2 = 0) = 
			                   (a/b +      bdv^^^2 = 0)"
  cancel_leading_coeff12:"Not (c =!= 0) ==> (a -      b*bdv^^^2 = 0) = 
			                   (a/b -      bdv^^^2 = 0)"
  cancel_leading_coeff13:"Not (c =!= 0) ==> (         b*bdv^^^2 = 0) = 
			                   (           bdv^^^2 = 0/b)"

  complete_square1:      "(q + p*bdv + bdv^^^2 = 0) = 
		         (q + (p/2 + bdv)^^^2 = (p/2)^^^2)"
  complete_square2:      "(    p*bdv + bdv^^^2 = 0) = 
		         (    (p/2 + bdv)^^^2 = (p/2)^^^2)"
  complete_square3:      "(      bdv + bdv^^^2 = 0) = 
		         (    (1/2 + bdv)^^^2 = (1/2)^^^2)"
		        
  complete_square4:      "(q - p*bdv + bdv^^^2 = 0) = 
		         (q + (p/2 - bdv)^^^2 = (p/2)^^^2)"
  complete_square5:      "(q + p*bdv - bdv^^^2 = 0) = 
		         (q + (p/2 - bdv)^^^2 = (p/2)^^^2)"

  square_explicit1:      "(a + b^^^2 = c) = ( b^^^2 = c - a)"
  square_explicit2:      "(a - b^^^2 = c) = (-(b^^^2) = c - a)"

  bdv_explicit1:         "(a + bdv = b) = (bdv = - a + b)"
  bdv_explicit2:         "(a - bdv = b) = ((-1)*bdv = - a + b)"
  bdv_explicit3:         "((-1)*bdv = b) = (bdv = (-1)*b)"

  plus_leq:              "(0 <= a + b) = ((-1)*b <= a)"(*Isa?*)
  minus_leq:             "(0 <= a - b) = (     b <= a)"(*Isa?*)

(*-- normalize --*)
  (*WN0509 compare LinEq.all_left "[|Not(b=!=0)|] ==> (a=b) = (a+(-1)*b=0)"*)
  all_left:              "[|Not(b=!=0)|] ==> (a = b) = (a - b = 0)"
  makex1_x:              "a^^^1  = a"  
  real_assoc_1:          "a+(b+c) = a+b+c"
  real_assoc_2:          "a*(b*c) = a*b*c"

(* ---- degree 0 ----*)
  d0_true:               "(0=0) = True"
  d0_false:              "[|Not(bdv occurs_in a);Not(a=0)|] ==> (a=0) = False"
(* ---- degree 1 ----*)
  d1_isolate_add1:
   "[|Not(bdv occurs_in a)|] ==> (a + b*bdv = 0) = (b*bdv = (-1)*a)"
  d1_isolate_add2:
   "[|Not(bdv occurs_in a)|] ==> (a +   bdv = 0) = (  bdv = (-1)*a)"
  d1_isolate_div:
   "[|Not(b=0);Not(bdv occurs_in c)|] ==> (b*bdv = c) = (bdv = c/b)"
(* ---- degree 2 ----*)
  d2_isolate_add1:
   "[|Not(bdv occurs_in a)|] ==> (a + b*bdv^^^2=0) = (b*bdv^^^2= (-1)*a)"
  d2_isolate_add2:
   "[|Not(bdv occurs_in a)|] ==> (a +   bdv^^^2=0) = (  bdv^^^2= (-1)*a)"
  d2_isolate_div:
   "[|Not(b=0);Not(bdv occurs_in c)|] ==> (b*bdv^^^2=c) = (bdv^^^2=c/b)"

  d2_prescind1:          "(a*bdv + b*bdv^^^2 = 0) = (bdv*(a +b*bdv)=0)"
  d2_prescind2:          "(a*bdv +   bdv^^^2 = 0) = (bdv*(a +  bdv)=0)"
  d2_prescind3:          "(  bdv + b*bdv^^^2 = 0) = (bdv*(1+b*bdv)=0)"
  d2_prescind4:          "(  bdv +   bdv^^^2 = 0) = (bdv*(1+  bdv)=0)"
  (* eliminate degree 2 *)
  (* thm for neg arguments in sqroot have postfix _neg *)
  d2_sqrt_equation1:     "[|(0<=c);Not(bdv occurs_in c)|] ==> 
                         (bdv^^^2=c) = ((bdv=sqrt c) | (bdv=(-1)*sqrt c ))"
  d2_sqrt_equation1_neg:
  "[|(c<0);Not(bdv occurs_in c)|] ==> (bdv^^^2=c) = False"
  d2_sqrt_equation2:     "(bdv^^^2=0) = (bdv=0)"
  d2_sqrt_equation3:     "(b*bdv^^^2=0) = (bdv=0)"
  d2_reduce_equation1:   "(bdv*(a +b*bdv)=0) = ((bdv=0)|(a+b*bdv=0))"
  d2_reduce_equation2:   "(bdv*(a +  bdv)=0) = ((bdv=0)|(a+  bdv=0))"
  d2_pqformula1:         "[|0<=p^^^2 - 4*q|] ==> (q+p*bdv+   bdv^^^2=0) =
                           ((bdv= (-1)*(p/2) + sqrt(p^^^2 - 4*q)/2) 
                          | (bdv= (-1)*(p/2) - sqrt(p^^^2 - 4*q)/2))"
  d2_pqformula1_neg:     "[|p^^^2 - 4*q<0|] ==> (q+p*bdv+   bdv^^^2=0) = False"
  d2_pqformula2:         "[|0<=p^^^2 - 4*q|] ==> (q+p*bdv+1*bdv^^^2=0) = 
                           ((bdv= (-1)*(p/2) + sqrt(p^^^2 - 4*q)/2) 
                          | (bdv= (-1)*(p/2) - sqrt(p^^^2 - 4*q)/2))"
  d2_pqformula2_neg:     "[|p^^^2 - 4*q<0|] ==> (q+p*bdv+1*bdv^^^2=0) = False"
  d2_pqformula3:         "[|0<=1 - 4*q|] ==> (q+  bdv+   bdv^^^2=0) = 
                           ((bdv= (-1)*(1/2) + sqrt(1 - 4*q)/2) 
                          | (bdv= (-1)*(1/2) - sqrt(1 - 4*q)/2))"
  d2_pqformula3_neg:     "[|1 - 4*q<0|] ==> (q+  bdv+   bdv^^^2=0) = False"
  d2_pqformula4:         "[|0<=1 - 4*q|] ==> (q+  bdv+1*bdv^^^2=0) = 
                           ((bdv= (-1)*(1/2) + sqrt(1 - 4*q)/2) 
                          | (bdv= (-1)*(1/2) - sqrt(1 - 4*q)/2))"
  d2_pqformula4_neg:     "[|1 - 4*q<0|] ==> (q+  bdv+1*bdv^^^2=0) = False"
  d2_pqformula5:         "[|0<=p^^^2 - 0|] ==> (  p*bdv+   bdv^^^2=0) =
                           ((bdv= (-1)*(p/2) + sqrt(p^^^2 - 0)/2) 
                          | (bdv= (-1)*(p/2) - sqrt(p^^^2 - 0)/2))"
  (* d2_pqformula5_neg not need p^2 never less zero in R *)
  d2_pqformula6:         "[|0<=p^^^2 - 0|] ==> (  p*bdv+1*bdv^^^2=0) = 
                           ((bdv= (-1)*(p/2) + sqrt(p^^^2 - 0)/2) 
                          | (bdv= (-1)*(p/2) - sqrt(p^^^2 - 0)/2))"
  (* d2_pqformula6_neg not need p^2 never less zero in R *)
  d2_pqformula7:        "[|0<=1 - 0|] ==> (    bdv+   bdv^^^2=0) = 
                           ((bdv= (-1)*(1/2) + sqrt(1 - 0)/2) 
                          | (bdv= (-1)*(1/2) - sqrt(1 - 0)/2))"
  (* d2_pqformula7_neg not need, because 1<0 ==> False*)
  d2_pqformula8:        "[|0<=1 - 0|] ==> (    bdv+1*bdv^^^2=0) = 
                           ((bdv= (-1)*(1/2) + sqrt(1 - 0)/2) 
                          | (bdv= (-1)*(1/2) - sqrt(1 - 0)/2))"
  (* d2_pqformula8_neg not need, because 1<0 ==> False*)
  d2_pqformula9:        "[|Not(bdv occurs_in q); 0<= (-1)*4*q|] ==> 
                           (q+    1*bdv^^^2=0) = ((bdv= 0 + sqrt(0 - 4*q)/2) 
                                                | (bdv= 0 - sqrt(0 - 4*q)/2))"
  d2_pqformula9_neg:
   "[|Not(bdv occurs_in q); (-1)*4*q<0|] ==> (q+    1*bdv^^^2=0) = False"
  d2_pqformula10:
   "[|Not(bdv occurs_in q); 0<= (-1)*4*q|] ==> (q+     bdv^^^2=0) = 
           ((bdv= 0 + sqrt(0 - 4*q)/2) 
          | (bdv= 0 - sqrt(0 - 4*q)/2))"
  d2_pqformula10_neg:
   "[|Not(bdv occurs_in q); (-1)*4*q<0|] ==> (q+     bdv^^^2=0) = False"
  d2_abcformula1:
   "[|0<=b^^^2 - 4*a*c|] ==> (c + b*bdv+a*bdv^^^2=0) =
           ((bdv=( -b + sqrt(b^^^2 - 4*a*c))/(2*a)) 
          | (bdv=( -b - sqrt(b^^^2 - 4*a*c))/(2*a)))"
  d2_abcformula1_neg:
   "[|b^^^2 - 4*a*c<0|] ==> (c + b*bdv+a*bdv^^^2=0) = False"
  d2_abcformula2:
   "[|0<=1 - 4*a*c|]     ==> (c+    bdv+a*bdv^^^2=0) = 
           ((bdv=( -1 + sqrt(1 - 4*a*c))/(2*a)) 
          | (bdv=( -1 - sqrt(1 - 4*a*c))/(2*a)))"
  d2_abcformula2_neg:
   "[|1 - 4*a*c<0|]     ==> (c+    bdv+a*bdv^^^2=0) = False"
  d2_abcformula3:
   "[|0<=b^^^2 - 4*1*c|] ==> (c + b*bdv+  bdv^^^2=0) =
           ((bdv=( -b + sqrt(b^^^2 - 4*1*c))/(2*1)) 
          | (bdv=( -b - sqrt(b^^^2 - 4*1*c))/(2*1)))"
  d2_abcformula3_neg:
   "[|b^^^2 - 4*1*c<0|] ==> (c + b*bdv+  bdv^^^2=0) = False"
  d2_abcformula4:
   "[|0<=1 - 4*1*c|] ==> (c +   bdv+  bdv^^^2=0) =
           ((bdv=( -1 + sqrt(1 - 4*1*c))/(2*1)) 
          | (bdv=( -1 - sqrt(1 - 4*1*c))/(2*1)))"
  d2_abcformula4_neg:
   "[|1 - 4*1*c<0|] ==> (c +   bdv+  bdv^^^2=0) = False"
  d2_abcformula5:
   "[|Not(bdv occurs_in c); 0<=0 - 4*a*c|] ==> (c +  a*bdv^^^2=0) =
           ((bdv=( 0 + sqrt(0 - 4*a*c))/(2*a)) 
          | (bdv=( 0 - sqrt(0 - 4*a*c))/(2*a)))"
  d2_abcformula5_neg:
   "[|Not(bdv occurs_in c); 0 - 4*a*c<0|] ==> (c +  a*bdv^^^2=0) = False"
  d2_abcformula6:
   "[|Not(bdv occurs_in c); 0<=0 - 4*1*c|]     ==> (c+    bdv^^^2=0) = 
           ((bdv=( 0 + sqrt(0 - 4*1*c))/(2*1)) 
          | (bdv=( 0 - sqrt(0 - 4*1*c))/(2*1)))"
  d2_abcformula6_neg:
   "[|Not(bdv occurs_in c); 0 - 4*1*c<0|]     ==> (c+    bdv^^^2=0) = False"
  d2_abcformula7:
   "[|0<=b^^^2 - 0|]     ==> (    b*bdv+a*bdv^^^2=0) = 
           ((bdv=( -b + sqrt(b^^^2 - 0))/(2*a)) 
          | (bdv=( -b - sqrt(b^^^2 - 0))/(2*a)))"
  (* d2_abcformula7_neg not need b^2 never less zero in R *)
  d2_abcformula8:
   "[|0<=b^^^2 - 0|] ==> (    b*bdv+  bdv^^^2=0) =
           ((bdv=( -b + sqrt(b^^^2 - 0))/(2*1)) 
          | (bdv=( -b - sqrt(b^^^2 - 0))/(2*1)))"
  (* d2_abcformula8_neg not need b^2 never less zero in R *)
  d2_abcformula9:
   "[|0<=1 - 0|]     ==> (      bdv+a*bdv^^^2=0) = 
           ((bdv=( -1 + sqrt(1 - 0))/(2*a)) 
          | (bdv=( -1 - sqrt(1 - 0))/(2*a)))"
  (* d2_abcformula9_neg not need, because 1<0 ==> False*)
  d2_abcformula10:
   "[|0<=1 - 0|] ==> (      bdv+  bdv^^^2=0) =
           ((bdv=( -1 + sqrt(1 - 0))/(2*1)) 
          | (bdv=( -1 - sqrt(1 - 0))/(2*1)))"
  (* d2_abcformula10_neg not need, because 1<0 ==> False*)

(* ---- degree 3 ----*)
  d3_reduce_equation1:
  "(a*bdv + b*bdv^^^2 + c*bdv^^^3=0) = (bdv=0 | (a + b*bdv + c*bdv^^^2=0))"
  d3_reduce_equation2:
  "(  bdv + b*bdv^^^2 + c*bdv^^^3=0) = (bdv=0 | (1 + b*bdv + c*bdv^^^2=0))"
  d3_reduce_equation3:
  "(a*bdv +   bdv^^^2 + c*bdv^^^3=0) = (bdv=0 | (a +   bdv + c*bdv^^^2=0))"
  d3_reduce_equation4:
  "(  bdv +   bdv^^^2 + c*bdv^^^3=0) = (bdv=0 | (1 +   bdv + c*bdv^^^2=0))"
  d3_reduce_equation5:
  "(a*bdv + b*bdv^^^2 +   bdv^^^3=0) = (bdv=0 | (a + b*bdv +   bdv^^^2=0))"
  d3_reduce_equation6:
  "(  bdv + b*bdv^^^2 +   bdv^^^3=0) = (bdv=0 | (1 + b*bdv +   bdv^^^2=0))"
  d3_reduce_equation7:
  "(a*bdv +   bdv^^^2 +   bdv^^^3=0) = (bdv=0 | (1 +   bdv +   bdv^^^2=0))"
  d3_reduce_equation8:
  "(  bdv +   bdv^^^2 +   bdv^^^3=0) = (bdv=0 | (1 +   bdv +   bdv^^^2=0))"
  d3_reduce_equation9:
  "(a*bdv             + c*bdv^^^3=0) = (bdv=0 | (a         + c*bdv^^^2=0))"
  d3_reduce_equation10:
  "(  bdv             + c*bdv^^^3=0) = (bdv=0 | (1         + c*bdv^^^2=0))"
  d3_reduce_equation11:
  "(a*bdv             +   bdv^^^3=0) = (bdv=0 | (a         +   bdv^^^2=0))"
  d3_reduce_equation12:
  "(  bdv             +   bdv^^^3=0) = (bdv=0 | (1         +   bdv^^^2=0))"
  d3_reduce_equation13:
  "(        b*bdv^^^2 + c*bdv^^^3=0) = (bdv=0 | (    b*bdv + c*bdv^^^2=0))"
  d3_reduce_equation14:
  "(          bdv^^^2 + c*bdv^^^3=0) = (bdv=0 | (      bdv + c*bdv^^^2=0))"
  d3_reduce_equation15:
  "(        b*bdv^^^2 +   bdv^^^3=0) = (bdv=0 | (    b*bdv +   bdv^^^2=0))"
  d3_reduce_equation16:
  "(          bdv^^^2 +   bdv^^^3=0) = (bdv=0 | (      bdv +   bdv^^^2=0))"
  d3_isolate_add1:
  "[|Not(bdv occurs_in a)|] ==> (a + b*bdv^^^3=0) = (b*bdv^^^3= (-1)*a)"
  d3_isolate_add2:
  "[|Not(bdv occurs_in a)|] ==> (a +   bdv^^^3=0) = (  bdv^^^3= (-1)*a)"
  d3_isolate_div:
   "[|Not(b=0);Not(bdv occurs_in a)|] ==> (b*bdv^^^3=c) = (bdv^^^3=c/b)"
  d3_root_equation2:
  "(bdv^^^3=0) = (bdv=0)"
  d3_root_equation1:
  "(bdv^^^3=c) = (bdv = nroot 3 c)"

(* ---- degree 4 ----*)
 (* RL03.FIXME es wir nicht getestet ob u>0 *)
 d4_sub_u1:
 "(c+b*bdv^^^2+a*bdv^^^4=0) =
   ((a*u^^^2+b*u+c=0) & (bdv^^^2=u))"

(* ---- 7.3.02 von Termorder ---- *)

  bdv_collect_1:      "l * bdv + m * bdv = (l + m) * bdv"
  bdv_collect_2:      "bdv + m * bdv = (1 + m) * bdv"
  bdv_collect_3:      "l * bdv + bdv = (l + 1) * bdv"

(*  bdv_collect_assoc0_1 "l * bdv + m * bdv + k = (l + m) * bdv + k"
    bdv_collect_assoc0_2 "bdv + m * bdv + k = (1 + m) * bdv + k"
    bdv_collect_assoc0_3 "l * bdv + bdv + k = (l + 1) * bdv + k"
*)
  bdv_collect_assoc1_1:"l * bdv + (m * bdv + k) = (l + m) * bdv + k"
  bdv_collect_assoc1_2:"bdv + (m * bdv + k) = (1 + m) * bdv + k"
  bdv_collect_assoc1_3:"l * bdv + (bdv + k) = (l + 1) * bdv + k"

  bdv_collect_assoc2_1:"k + l * bdv + m * bdv = k + (l + m) * bdv"
  bdv_collect_assoc2_2:"k + bdv + m * bdv = k + (1 + m) * bdv"
  bdv_collect_assoc2_3:"k + l * bdv + bdv = k + (l + 1) * bdv"


  bdv_n_collect_1:     "l * bdv^^^n + m * bdv^^^n = (l + m) * bdv^^^n"
  bdv_n_collect_2:     " bdv^^^n + m * bdv^^^n = (1 + m) * bdv^^^n"
  bdv_n_collect_3:     "l * bdv^^^n + bdv^^^n = (l + 1) * bdv^^^n"   (*order!*)

  bdv_n_collect_assoc1_1:"l * bdv^^^n + (m * bdv^^^n + k) = (l + m) * bdv^^^n + k"
  bdv_n_collect_assoc1_2:"bdv^^^n + (m * bdv^^^n + k) = (1 + m) * bdv^^^n + k"
  bdv_n_collect_assoc1_3:"l * bdv^^^n + (bdv^^^n + k) = (l + 1) * bdv^^^n + k"

  bdv_n_collect_assoc2_1:"k + l * bdv^^^n + m * bdv^^^n = k + (l + m) * bdv^^^n"
  bdv_n_collect_assoc2_2:"k + bdv^^^n + m * bdv^^^n = k + (1 + m) * bdv^^^n"
  bdv_n_collect_assoc2_3:"k + l * bdv^^^n + bdv^^^n = k + (l + 1) * bdv^^^n"

(*WN.14.3.03*)
  real_minus_div:        "- (a / b) = (-1 * a) / b"

  separate_bdv:          "(a * bdv) / b = (a / b) * bdv"
  separate_bdv_n:        "(a * bdv ^^^ n) / b = (a / b) * bdv ^^^ n"
  separate_1_bdv:        "bdv / b = (1 / b) * bdv"
  separate_1_bdv_n:      "bdv ^^^ n / b = (1 / b) * bdv ^^^ n"

ML {*
val thy = @{theory};

(*-------------------------rulse-------------------------*)
val PolyEq_prls = (*3.10.02:just the following order due to subterm evaluation*)
  append_rls "PolyEq_prls" e_rls 
	     [Calc ("Atools.ident",eval_ident "#ident_"),
	      Calc ("Tools.matches",eval_matches ""),
	      Calc ("Tools.lhs"    ,eval_lhs ""),
	      Calc ("Tools.rhs"    ,eval_rhs ""),
	      Calc ("Poly.is'_expanded'_in",eval_is_expanded_in ""),
	      Calc ("Poly.is'_poly'_in",eval_is_poly_in ""),
	      Calc ("Poly.has'_degree'_in",eval_has_degree_in ""),    
              Calc ("Poly.is'_polyrat'_in",eval_is_polyrat_in ""),
	      (*Calc ("Atools.occurs'_in",eval_occurs_in ""),   *) 
	      (*Calc ("Atools.is'_const",eval_const "#is_const_"),*)
	      Calc ("op =",eval_equal "#equal_"),
              Calc ("RootEq.is'_rootTerm'_in",eval_is_rootTerm_in ""),
	      Calc ("RatEq.is'_ratequation'_in",eval_is_ratequation_in ""),
	      Thm ("not_true",num_str @{thm not_true}),
	      Thm ("not_false",num_str @{thm not_false}),
	      Thm ("and_true",num_str @{thm and_true}),
	      Thm ("and_false",num_str @{thm and_false}),
	      Thm ("or_true",num_str @{thm or_true}),
	      Thm ("or_false",num_str @{thm or_false})
	       ];

val PolyEq_erls = 
    merge_rls "PolyEq_erls" LinEq_erls
    (append_rls "ops_preds" calculate_Rational
		[Calc ("op =",eval_equal "#equal_"),
		 Thm ("plus_leq", num_str @{thm plus_leq}),
		 Thm ("minus_leq", num_str @{thm minus_leq}),
		 Thm ("rat_leq1", num_str @{thm rat_leq1}),
		 Thm ("rat_leq2", num_str @{thm rat_leq2}),
		 Thm ("rat_leq3", num_str @{thm rat_leq3})
		 ]);

val PolyEq_crls = 
    merge_rls "PolyEq_crls" LinEq_crls
    (append_rls "ops_preds" calculate_Rational
		[Calc ("op =",eval_equal "#equal_"),
		 Thm ("plus_leq", num_str @{thm plus_leq}),
		 Thm ("minus_leq", num_str @{thm minus_leq}),
		 Thm ("rat_leq1", num_str @{thm rat_leq1}),
		 Thm ("rat_leq2", num_str @{thm rat_leq2}),
		 Thm ("rat_leq3", num_str @{thm rat_leq3})
		 ]);

val cancel_leading_coeff = prep_rls(
  Rls {id = "cancel_leading_coeff", preconds = [], 
       rew_ord = ("e_rew_ord",e_rew_ord),
      erls = PolyEq_erls, srls = Erls, calc = [], (*asm_thm = [],*)
      rules = 
      [Thm ("cancel_leading_coeff1",num_str @{thm cancel_leading_coeff1}),
       Thm ("cancel_leading_coeff2",num_str @{thm cancel_leading_coeff2}),
       Thm ("cancel_leading_coeff3",num_str @{thm cancel_leading_coeff3}),
       Thm ("cancel_leading_coeff4",num_str @{thm cancel_leading_coeff4}),
       Thm ("cancel_leading_coeff5",num_str @{thm cancel_leading_coeff5}),
       Thm ("cancel_leading_coeff6",num_str @{thm cancel_leading_coeff6}),
       Thm ("cancel_leading_coeff7",num_str @{thm cancel_leading_coeff7}),
       Thm ("cancel_leading_coeff8",num_str @{thm cancel_leading_coeff8}),
       Thm ("cancel_leading_coeff9",num_str @{thm cancel_leading_coeff9}),
       Thm ("cancel_leading_coeff10",num_str @{thm cancel_leading_coeff10}),
       Thm ("cancel_leading_coeff11",num_str @{thm cancel_leading_coeff11}),
       Thm ("cancel_leading_coeff12",num_str @{thm cancel_leading_coeff12}),
       Thm ("cancel_leading_coeff13",num_str @{thm cancel_leading_coeff13})
       ],scr = Script ((term_of o the o (parse thy)) "empty_script")}:rls);
*}
ML{*
val complete_square = prep_rls(
  Rls {id = "complete_square", preconds = [], 
       rew_ord = ("e_rew_ord",e_rew_ord),
      erls = PolyEq_erls, srls = Erls, calc = [], (*asm_thm = [],*)
      rules = [Thm ("complete_square1",num_str @{thm complete_square1}),
	       Thm ("complete_square2",num_str @{thm complete_square2}),
	       Thm ("complete_square3",num_str @{thm complete_square3}),
	       Thm ("complete_square4",num_str @{thm complete_square4}),
	       Thm ("complete_square5",num_str @{thm complete_square5})
	       ],
      scr = Script ((term_of o the o (parse thy)) 
      "empty_script")
      }:rls);

val polyeq_simplify = prep_rls(
  Rls {id = "polyeq_simplify", preconds = [], 
       rew_ord = ("termlessI",termlessI), 
       erls = PolyEq_erls, 
       srls = Erls, 
       calc = [], 
       (*asm_thm = [],*)
       rules = [Thm  ("real_assoc_1",num_str @{thm real_assoc_1}),
		Thm  ("real_assoc_2",num_str @{thm real_assoc_2}),
		Thm  ("real_diff_minus",num_str @{thm real_diff_minus}),
		Thm  ("real_unari_minus",num_str @{thm real_unari_minus}),
		Thm  ("realpow_multI",num_str @{thm realpow_multI}),
		Calc ("op +",eval_binop "#add_"),
		Calc ("op -",eval_binop "#sub_"),
		Calc ("op *",eval_binop "#mult_"),
		Calc ("HOL.divide", eval_cancel "#divide_e"),
		Calc ("NthRoot.sqrt",eval_sqrt "#sqrt_"),
		Calc ("Atools.pow" ,eval_binop "#power_"),
                Rls_ reduce_012
                ],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
       }:rls);

ruleset' := overwritelthy @{theory} (!ruleset',
		[("cancel_leading_coeff",cancel_leading_coeff),
		 ("complete_square",complete_square),
		 ("PolyEq_erls",PolyEq_erls),(*FIXXXME:del with rls.rls'*)
		 ("polyeq_simplify",polyeq_simplify)]);

*}
ML{*

(* ------------- polySolve ------------------ *)
(* -- d0 -- *)
(*isolate the bound variable in an d0 equation; 'bdv' is a meta-constant*)
val d0_polyeq_simplify = prep_rls(
  Rls {id = "d0_polyeq_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord),
       erls = PolyEq_erls,
       srls = Erls, 
       calc = [], 
       (*asm_thm = [],*)
       rules = [Thm("d0_true",num_str @{thm d0_true}),
		Thm("d0_false",num_str @{thm  d0_false})
		],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
       }:rls);

(* -- d1 -- *)
(*isolate the bound variable in an d1 equation; 'bdv' is a meta-constant*)
val d1_polyeq_simplify = prep_rls(
  Rls {id = "d1_polyeq_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord),
       erls = PolyEq_erls,
       srls = Erls, 
       calc = [], 
       (*asm_thm = [("d1_isolate_div","")],*)
       rules = [
		Thm("d1_isolate_add1",num_str @{thm d1_isolate_add1}), 
		(* a+bx=0 -> bx=-a *)
		Thm("d1_isolate_add2",num_str @{thm d1_isolate_add2}), 
		(* a+ x=0 ->  x=-a *)
		Thm("d1_isolate_div",num_str @{thm d1_isolate_div})    
		(*   bx=c -> x=c/b *)  
		],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
       }:rls);

*}
ML{*
(* -- d2 -- *)
(* isolate the bound variable in an d2 equation with bdv only; 
   'bdv' is a meta-constant*)
val d2_polyeq_bdv_only_simplify = prep_rls(
  Rls {id = "d2_polyeq_bdv_only_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord),
       erls = PolyEq_erls,
       srls = Erls, 
       calc = [], 
       (*asm_thm = [("d2_sqrt_equation1",""),("d2_sqrt_equation1_neg",""),
                  ("d2_isolate_div","")],*)
       rules = [Thm("d2_prescind1",num_str @{thm d2_prescind1}),
                (*   ax+bx^2=0 -> x(a+bx)=0 *)
		Thm("d2_prescind2",num_str @{thm d2_prescind2}),
                (*   ax+ x^2=0 -> x(a+ x)=0 *)
		Thm("d2_prescind3",num_str @{thm d2_prescind3}),
                (*    x+bx^2=0 -> x(1+bx)=0 *)
		Thm("d2_prescind4",num_str @{thm d2_prescind4}),
                (*    x+ x^2=0 -> x(1+ x)=0 *)
		Thm("d2_sqrt_equation1",num_str @{thm d2_sqrt_equation1}),
                (* x^2=c   -> x=+-sqrt(c)*)
		Thm("d2_sqrt_equation1_neg",num_str @{thm d2_sqrt_equation1_neg}),
                (* [0<c] x^2=c  -> [] *)
		Thm("d2_sqrt_equation2",num_str @{thm d2_sqrt_equation2}),
                (*  x^2=0 ->    x=0    *)
		Thm("d2_reduce_equation1",num_str @{thm d2_reduce_equation1}),
                (* x(a+bx)=0 -> x=0 | a+bx=0*)
		Thm("d2_reduce_equation2",num_str @{thm d2_reduce_equation2}),
                (* x(a+ x)=0 -> x=0 | a+ x=0*)
		Thm("d2_isolate_div",num_str @{thm d2_isolate_div})
                (* bx^2=c -> x^2=c/b*)
		],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
       }:rls);
*}
ML{*
(* isolate the bound variable in an d2 equation with sqrt only; 
   'bdv' is a meta-constant*)
val d2_polyeq_sq_only_simplify = prep_rls(
  Rls {id = "d2_polyeq_sq_only_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord),
       erls = PolyEq_erls,
       srls = Erls, 
       calc = [], 
       (*asm_thm = [("d2_sqrt_equation1",""),("d2_sqrt_equation1_neg",""),
                  ("d2_isolate_div","")],*)
       rules = [Thm("d2_isolate_add1",num_str @{thm d2_isolate_add1}),
                (* a+   bx^2=0 -> bx^2=(-1)a*)
		Thm("d2_isolate_add2",num_str @{thm d2_isolate_add2}),
                (* a+    x^2=0 ->  x^2=(-1)a*)
		Thm("d2_sqrt_equation2",num_str @{thm d2_sqrt_equation2}),
                (*  x^2=0 ->    x=0    *)
		Thm("d2_sqrt_equation1",num_str @{thm d2_sqrt_equation1}),
                (* x^2=c   -> x=+-sqrt(c)*)
		Thm("d2_sqrt_equation1_neg",num_str @{thm d2_sqrt_equation1_neg}),
                (* [c<0] x^2=c  -> x=[] *)
		Thm("d2_isolate_div",num_str @{thm d2_isolate_div})
                 (* bx^2=c -> x^2=c/b*)
		],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
       }:rls);
*}
ML{*
(* isolate the bound variable in an d2 equation with pqFormula;
   'bdv' is a meta-constant*)
val d2_polyeq_pqFormula_simplify = prep_rls(
  Rls {id = "d2_polyeq_pqFormula_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord), erls = PolyEq_erls,
       srls = Erls, calc = [], 
       rules = [Thm("d2_pqformula1",num_str @{thm d2_pqformula1}),
                (* q+px+ x^2=0 *)
		Thm("d2_pqformula1_neg",num_str @{thm d2_pqformula1_neg}),
                (* q+px+ x^2=0 *)
		Thm("d2_pqformula2",num_str @{thm d2_pqformula2}), 
                (* q+px+1x^2=0 *)
		Thm("d2_pqformula2_neg",num_str @{thm d2_pqformula2_neg}),
                (* q+px+1x^2=0 *)
		Thm("d2_pqformula3",num_str @{thm d2_pqformula3}),
                (* q+ x+ x^2=0 *)
		Thm("d2_pqformula3_neg",num_str @{thm d2_pqformula3_neg}), 
                (* q+ x+ x^2=0 *)
		Thm("d2_pqformula4",num_str @{thm d2_pqformula4}),
                (* q+ x+1x^2=0 *)
		Thm("d2_pqformula4_neg",num_str @{thm d2_pqformula4_neg}),
                (* q+ x+1x^2=0 *)
		Thm("d2_pqformula5",num_str @{thm d2_pqformula5}),
                (*   qx+ x^2=0 *)
		Thm("d2_pqformula6",num_str @{thm d2_pqformula6}),
                (*   qx+1x^2=0 *)
		Thm("d2_pqformula7",num_str @{thm d2_pqformula7}),
                (*    x+ x^2=0 *)
		Thm("d2_pqformula8",num_str @{thm d2_pqformula8}),
                (*    x+1x^2=0 *)
		Thm("d2_pqformula9",num_str @{thm d2_pqformula9}),
                (* q   +1x^2=0 *)
		Thm("d2_pqformula9_neg",num_str @{thm d2_pqformula9_neg}),
                (* q   +1x^2=0 *)
		Thm("d2_pqformula10",num_str @{thm d2_pqformula10}),
                (* q   + x^2=0 *)
		Thm("d2_pqformula10_neg",num_str @{thm d2_pqformula10_neg}),
                (* q   + x^2=0 *)
		Thm("d2_sqrt_equation2",num_str @{thm d2_sqrt_equation2}),
                (*       x^2=0 *)
		Thm("d2_sqrt_equation3",num_str @{thm d2_sqrt_equation3})
               (*      1x^2=0 *)
	       ],scr = Script ((term_of o the o (parse thy)) "empty_script")
       }:rls);
*}
ML{*
(* isolate the bound variable in an d2 equation with abcFormula; 
   'bdv' is a meta-constant*)
val d2_polyeq_abcFormula_simplify = prep_rls(
  Rls {id = "d2_polyeq_abcFormula_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord), erls = PolyEq_erls,
       srls = Erls, calc = [], 
       rules = [Thm("d2_abcformula1",num_str @{thm d2_abcformula1}),
                (*c+bx+cx^2=0 *)
		Thm("d2_abcformula1_neg",num_str @{thm d2_abcformula1_neg}),
                (*c+bx+cx^2=0 *)
		Thm("d2_abcformula2",num_str @{thm d2_abcformula2}),
                (*c+ x+cx^2=0 *)
		Thm("d2_abcformula2_neg",num_str @{thm d2_abcformula2_neg}),
                (*c+ x+cx^2=0 *)
		Thm("d2_abcformula3",num_str @{thm d2_abcformula3}), 
                (*c+bx+ x^2=0 *)
		Thm("d2_abcformula3_neg",num_str @{thm d2_abcformula3_neg}),
                (*c+bx+ x^2=0 *)
		Thm("d2_abcformula4",num_str @{thm d2_abcformula4}),
                (*c+ x+ x^2=0 *)
		Thm("d2_abcformula4_neg",num_str @{thm d2_abcformula4_neg}),
                (*c+ x+ x^2=0 *)
		Thm("d2_abcformula5",num_str @{thm d2_abcformula5}),
                (*c+   cx^2=0 *)
		Thm("d2_abcformula5_neg",num_str @{thm d2_abcformula5_neg}),
                (*c+   cx^2=0 *)
		Thm("d2_abcformula6",num_str @{thm d2_abcformula6}),
                (*c+    x^2=0 *)
		Thm("d2_abcformula6_neg",num_str @{thm d2_abcformula6_neg}),
                (*c+    x^2=0 *)
		Thm("d2_abcformula7",num_str @{thm d2_abcformula7}),
                (*  bx+ax^2=0 *)
		Thm("d2_abcformula8",num_str @{thm d2_abcformula8}),
                (*  bx+ x^2=0 *)
		Thm("d2_abcformula9",num_str @{thm d2_abcformula9}),
                (*   x+ax^2=0 *)
		Thm("d2_abcformula10",num_str @{thm d2_abcformula10}),
                (*   x+ x^2=0 *)
		Thm("d2_sqrt_equation2",num_str @{thm d2_sqrt_equation2}),
                (*      x^2=0 *)  
		Thm("d2_sqrt_equation3",num_str @{thm d2_sqrt_equation3})
               (*     bx^2=0 *)  
	       ],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
       }:rls);
*}
ML{*

(* isolate the bound variable in an d2 equation; 
   'bdv' is a meta-constant*)
val d2_polyeq_simplify = prep_rls(
  Rls {id = "d2_polyeq_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord), erls = PolyEq_erls,
       srls = Erls, calc = [], 
       rules = [Thm("d2_pqformula1",num_str @{thm d2_pqformula1}),
                (* p+qx+ x^2=0 *)
		Thm("d2_pqformula1_neg",num_str @{thm d2_pqformula1_neg}),
                (* p+qx+ x^2=0 *)
		Thm("d2_pqformula2",num_str @{thm d2_pqformula2}),
                (* p+qx+1x^2=0 *)
		Thm("d2_pqformula2_neg",num_str @{thm d2_pqformula2_neg}),
                (* p+qx+1x^2=0 *)
		Thm("d2_pqformula3",num_str @{thm d2_pqformula3}),
                (* p+ x+ x^2=0 *)
		Thm("d2_pqformula3_neg",num_str @{thm d2_pqformula3_neg}),
                (* p+ x+ x^2=0 *)
		Thm("d2_pqformula4",num_str @{thm d2_pqformula4}), 
                (* p+ x+1x^2=0 *)
		Thm("d2_pqformula4_neg",num_str @{thm d2_pqformula4_neg}),
                (* p+ x+1x^2=0 *)
		Thm("d2_abcformula1",num_str @{thm d2_abcformula1}),
                (* c+bx+cx^2=0 *)
		Thm("d2_abcformula1_neg",num_str @{thm d2_abcformula1_neg}),
                (* c+bx+cx^2=0 *)
		Thm("d2_abcformula2",num_str @{thm d2_abcformula2}),
                (* c+ x+cx^2=0 *)
		Thm("d2_abcformula2_neg",num_str @{thm d2_abcformula2_neg}),
                (* c+ x+cx^2=0 *)
		Thm("d2_prescind1",num_str @{thm d2_prescind1}),
                (*   ax+bx^2=0 -> x(a+bx)=0 *)
		Thm("d2_prescind2",num_str @{thm d2_prescind2}),
                (*   ax+ x^2=0 -> x(a+ x)=0 *)
		Thm("d2_prescind3",num_str @{thm d2_prescind3}),
                (*    x+bx^2=0 -> x(1+bx)=0 *)
		Thm("d2_prescind4",num_str @{thm d2_prescind4}),
                (*    x+ x^2=0 -> x(1+ x)=0 *)
		Thm("d2_isolate_add1",num_str @{thm d2_isolate_add1}),
                (* a+   bx^2=0 -> bx^2=(-1)a*)
		Thm("d2_isolate_add2",num_str @{thm d2_isolate_add2}),
                (* a+    x^2=0 ->  x^2=(-1)a*)
		Thm("d2_sqrt_equation1",num_str @{thm d2_sqrt_equation1}),
                (* x^2=c   -> x=+-sqrt(c)*)
		Thm("d2_sqrt_equation1_neg",num_str @{thm d2_sqrt_equation1_neg}),
                (* [c<0] x^2=c   -> x=[]*)
		Thm("d2_sqrt_equation2",num_str @{thm d2_sqrt_equation2}),
                (*  x^2=0 ->    x=0    *)
		Thm("d2_reduce_equation1",num_str @{thm d2_reduce_equation1}),
                (* x(a+bx)=0 -> x=0 | a+bx=0*)
		Thm("d2_reduce_equation2",num_str @{thm d2_reduce_equation2}),
                (* x(a+ x)=0 -> x=0 | a+ x=0*)
		Thm("d2_isolate_div",num_str @{thm d2_isolate_div})
               (* bx^2=c -> x^2=c/b*)
	       ],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
      }:rls);
*}
ML{*

(* -- d3 -- *)
(* isolate the bound variable in an d3 equation; 'bdv' is a meta-constant *)
val d3_polyeq_simplify = prep_rls(
  Rls {id = "d3_polyeq_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord), erls = PolyEq_erls,
       srls = Erls, calc = [], 
       rules = 
       [Thm("d3_reduce_equation1",num_str @{thm d3_reduce_equation1}),
	(*a*bdv + b*bdv^^^2 + c*bdv^^^3=0) = 
        (bdv=0 | (a + b*bdv + c*bdv^^^2=0)*)
	Thm("d3_reduce_equation2",num_str @{thm d3_reduce_equation2}),
	(*  bdv + b*bdv^^^2 + c*bdv^^^3=0) = 
        (bdv=0 | (1 + b*bdv + c*bdv^^^2=0)*)
	Thm("d3_reduce_equation3",num_str @{thm d3_reduce_equation3}),
	(*a*bdv +   bdv^^^2 + c*bdv^^^3=0) = 
        (bdv=0 | (a +   bdv + c*bdv^^^2=0)*)
	Thm("d3_reduce_equation4",num_str @{thm d3_reduce_equation4}),
	(*  bdv +   bdv^^^2 + c*bdv^^^3=0) = 
        (bdv=0 | (1 +   bdv + c*bdv^^^2=0)*)
	Thm("d3_reduce_equation5",num_str @{thm d3_reduce_equation5}),
	(*a*bdv + b*bdv^^^2 +   bdv^^^3=0) = 
        (bdv=0 | (a + b*bdv +   bdv^^^2=0)*)
	Thm("d3_reduce_equation6",num_str @{thm d3_reduce_equation6}),
	(*  bdv + b*bdv^^^2 +   bdv^^^3=0) = 
        (bdv=0 | (1 + b*bdv +   bdv^^^2=0)*)
	Thm("d3_reduce_equation7",num_str @{thm d3_reduce_equation7}),
	     (*a*bdv +   bdv^^^2 +   bdv^^^3=0) = 
             (bdv=0 | (1 +   bdv +   bdv^^^2=0)*)
	Thm("d3_reduce_equation8",num_str @{thm d3_reduce_equation8}),
	     (*  bdv +   bdv^^^2 +   bdv^^^3=0) = 
             (bdv=0 | (1 +   bdv +   bdv^^^2=0)*)
	Thm("d3_reduce_equation9",num_str @{thm d3_reduce_equation9}),
	     (*a*bdv             + c*bdv^^^3=0) = 
             (bdv=0 | (a         + c*bdv^^^2=0)*)
	Thm("d3_reduce_equation10",num_str @{thm d3_reduce_equation10}),
	     (*  bdv             + c*bdv^^^3=0) = 
             (bdv=0 | (1         + c*bdv^^^2=0)*)
	Thm("d3_reduce_equation11",num_str @{thm d3_reduce_equation11}),
	     (*a*bdv             +   bdv^^^3=0) = 
             (bdv=0 | (a         +   bdv^^^2=0)*)
	Thm("d3_reduce_equation12",num_str @{thm d3_reduce_equation12}),
	     (*  bdv             +   bdv^^^3=0) = 
             (bdv=0 | (1         +   bdv^^^2=0)*)
	Thm("d3_reduce_equation13",num_str @{thm d3_reduce_equation13}),
	     (*        b*bdv^^^2 + c*bdv^^^3=0) = 
             (bdv=0 | (    b*bdv + c*bdv^^^2=0)*)
	Thm("d3_reduce_equation14",num_str @{thm d3_reduce_equation14}),
	     (*          bdv^^^2 + c*bdv^^^3=0) = 
             (bdv=0 | (      bdv + c*bdv^^^2=0)*)
	Thm("d3_reduce_equation15",num_str @{thm d3_reduce_equation15}),
	     (*        b*bdv^^^2 +   bdv^^^3=0) = 
             (bdv=0 | (    b*bdv +   bdv^^^2=0)*)
	Thm("d3_reduce_equation16",num_str @{thm d3_reduce_equation16}),
	     (*          bdv^^^2 +   bdv^^^3=0) = 
             (bdv=0 | (      bdv +   bdv^^^2=0)*)
	Thm("d3_isolate_add1",num_str @{thm d3_isolate_add1}),
	     (*[|Not(bdv occurs_in a)|] ==> (a + b*bdv^^^3=0) = 
              (bdv=0 | (b*bdv^^^3=a)*)
	Thm("d3_isolate_add2",num_str @{thm d3_isolate_add2}),
             (*[|Not(bdv occurs_in a)|] ==> (a +   bdv^^^3=0) = 
              (bdv=0 | (  bdv^^^3=a)*)
	Thm("d3_isolate_div",num_str @{thm d3_isolate_div}),
        (*[|Not(b=0)|] ==> (b*bdv^^^3=c) = (bdv^^^3=c/b*)
        Thm("d3_root_equation2",num_str @{thm d3_root_equation2}),
        (*(bdv^^^3=0) = (bdv=0) *)
	Thm("d3_root_equation1",num_str @{thm d3_root_equation1})
       (*bdv^^^3=c) = (bdv = nroot 3 c*)
       ],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
      }:rls);
*}
ML{*

(* -- d4 -- *)
(*isolate the bound variable in an d4 equation; 'bdv' is a meta-constant*)
val d4_polyeq_simplify = prep_rls(
  Rls {id = "d4_polyeq_simplify", preconds = [],
       rew_ord = ("e_rew_ord",e_rew_ord), erls = PolyEq_erls,
       srls = Erls, calc = [], 
       rules = 
       [Thm("d4_sub_u1",num_str @{thm d4_sub_u1})  
       (* ax^4+bx^2+c=0 -> x=+-sqrt(ax^2+bx^+c) *)
       ],
       scr = Script ((term_of o the o (parse thy)) "empty_script")
      }:rls);
  
ruleset' := 
overwritelthy @{theory} 
              (!ruleset',
               [("d0_polyeq_simplify", d0_polyeq_simplify),
                ("d1_polyeq_simplify", d1_polyeq_simplify),
                ("d2_polyeq_simplify", d2_polyeq_simplify),
                ("d2_polyeq_bdv_only_simplify", d2_polyeq_bdv_only_simplify),
                ("d2_polyeq_sq_only_simplify", d2_polyeq_sq_only_simplify),
                ("d2_polyeq_pqFormula_simplify", d2_polyeq_pqFormula_simplify),
                ("d2_polyeq_abcFormula_simplify", 
                 d2_polyeq_abcFormula_simplify),
                ("d3_polyeq_simplify", d3_polyeq_simplify),
		("d4_polyeq_simplify", d4_polyeq_simplify)
	      ]);
*}
ML{*
    
(*------------------------problems------------------------*)
(*
(get_pbt ["degree_2","polynomial","univariate","equation"]);
show_ptyps(); 
*)

(*-------------------------poly-----------------------*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_poly" [] e_pblID
 (["polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["~((e_e::bool) is_ratequation_in (v_v::real))",
	       "~((lhs e_e) is_rootTerm_in (v_v::real))",
	       "~((rhs e_e) is_rootTerm_in (v_v::real))"]),
   ("#Find"  ,["solutions v_v'i'"])
   ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  []));
(*--- d0 ---*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg0" [] e_pblID
 (["degree_0","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a = 0) e_e",
	       "(lhs e_e) is_poly_in v_v",
	       "((lhs e_e) has_degree_in v_v ) = 0"
	      ]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","solve_d0_polyeq_equation"]]));

(*--- d1 ---*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg1" [] e_pblID
 (["degree_1","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a = 0) e_e",
	       "(lhs e_e) is_poly_in v_v",
	       "((lhs e_e) has_degree_in v_v ) = 1"
	      ]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","solve_d1_polyeq_equation"]]));
*}
ML{*
(*--- d2 ---*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg2" [] e_pblID
 (["degree_2","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a = 0) e_e",
	       "(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v ) = 2"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","solve_d2_polyeq_equation"]]));

 store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg2_sqonly" [] e_pblID
 (["sq_only","degree_2","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches ( ?a +    ?v_^^^2 = 0) e_e | " ^
	       "matches ( ?a + ?b*?v_^^^2 = 0) e_e | " ^
	       "matches (         ?v_^^^2 = 0) e_e | " ^
	       "matches (      ?b*?v_^^^2 = 0) e_e" ,
	       "Not (matches (?a +    ?v_ +    ?v_^^^2 = 0) e_e) &" ^
	       "Not (matches (?a + ?b*?v_ +    ?v_^^^2 = 0) e_e) &" ^
	       "Not (matches (?a +    ?v_ + ?c*?v_^^^2 = 0) e_e) &" ^
	       "Not (matches (?a + ?b*?v_ + ?c*?v_^^^2 = 0) e_e) &" ^
	       "Not (matches (        ?v_ +    ?v_^^^2 = 0) e_e) &" ^
	       "Not (matches (     ?b*?v_ +    ?v_^^^2 = 0) e_e) &" ^
	       "Not (matches (        ?v_ + ?c*?v_^^^2 = 0) e_e) &" ^
	       "Not (matches (     ?b*?v_ + ?c*?v_^^^2 = 0) e_e)"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","solve_d2_polyeq_sqonly_equation"]]));

store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg2_bdvonly" [] e_pblID
 (["bdv_only","degree_2","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a*?v_ +    ?v_^^^2 = 0) e_e | " ^
	       "matches (   ?v_ +    ?v_^^^2 = 0) e_e | " ^
	       "matches (   ?v_ + ?b*?v_^^^2 = 0) e_e | " ^
	       "matches (?a*?v_ + ?b*?v_^^^2 = 0) e_e | " ^
	       "matches (            ?v_^^^2 = 0) e_e | " ^
	       "matches (         ?b*?v_^^^2 = 0) e_e "]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","solve_d2_polyeq_bdvonly_equation"]]));

store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg2_pq" [] e_pblID
 (["pqFormula","degree_2","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a + 1*?v_^^^2 = 0) e_e | " ^
	       "matches (?a +   ?v_^^^2 = 0) e_e"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","solve_d2_polyeq_pq_equation"]]));

store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg2_abc" [] e_pblID
 (["abcFormula","degree_2","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a +    ?v_^^^2 = 0) e_e | " ^
	       "matches (?a + ?b*?v_^^^2 = 0) e_e"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","solve_d2_polyeq_abc_equation"]]));
*}
ML{*
(*--- d3 ---*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg3" [] e_pblID
 (["degree_3","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a = 0) e_e",
	       "(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 3"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","solve_d3_polyeq_equation"]]));

(*--- d4 ---*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_deg4" [] e_pblID
 (["degree_4","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a = 0) e_e",
	       "(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 4"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [(*["PolyEq","solve_d4_polyeq_equation"]*)]));

(*--- normalize ---*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_poly_norm" [] e_pblID
 (["normalize","polynomial","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(Not((matches (?a = 0 ) e_e ))) |" ^
	       "(Not(((lhs e_e) is_poly_in v_v)))"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","normalize_poly"]]));
(*-------------------------expanded-----------------------*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_expand" [] e_pblID
 (["expanded","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a = 0) e_e",
	       "(lhs e_e) is_expanded_in v_v "]),
   ("#Find"  ,["solutions v_v'i'"])
   ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  []));

(*--- d2 ---*)
store_pbt
 (prep_pbt thy "pbl_equ_univ_expand_deg2" [] e_pblID
 (["degree_2","expanded","univariate","equation"],
  [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["((lhs e_e) has_degree_in v_v) = 2"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
  PolyEq_prls, SOME "solve (e_e::bool, v_v)",
  [["PolyEq","complete_square"]]));

*}
ML{*
val scr =     
    "Script Normalize_poly (e_e::bool) (v_v::real) =                     " ^
    "(let e_e =((Try         (Rewrite     all_left          False)) @@  " ^ 
    "          (Try (Repeat (Rewrite     makex1_x         False))) @@  " ^ 
    "          (Try (Repeat (Rewrite_Set expand_binoms    False))) @@  " ^ 
    "          (Try (Repeat (Rewrite_Set_Inst [(bdv,v_v::real)]         " ^
    "                                 make_ratpoly_in     False))) @@  " ^
    "          (Try (Repeat (Rewrite_Set polyeq_simplify  False)))) e_e " ^
    " in (SubProblem (PolyEq',[polynomial,univariate,equation], [no_met])   " ^
    "                 [BOOL e_e, REAL v_v]))";
parse thy scr;
*}
ML{*
"-------------------------methods-----------------------";
store_met
 (prep_met thy "met_polyeq" [] e_metID
 (["PolyEq"],
   [],
   {rew_ord'="tless_true",rls'=Atools_erls,calc = [], srls = e_rls, prls=e_rls,
    crls=PolyEq_crls, nrls=norm_Rational}, "empty_script"));

store_met
 (prep_met thy "met_polyeq_norm" [] e_metID
 (["PolyEq","normalize_poly"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(Not((matches (?a = 0 ) e_e ))) |" ^
	       "(Not(((lhs e_e) is_poly_in v_v)))"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",
    rls'=PolyEq_erls,
    srls=e_rls,
    prls=PolyEq_prls,
    calc=[],
    crls=PolyEq_crls, nrls=norm_Rational},
    "Script Normalize_poly (e_e::bool) (v_v::real) =                     " ^
    "(let e_e =((Try         (Rewrite     all_left          False)) @@  " ^ 
    "          (Try (Repeat (Rewrite     makex1_x         False))) @@  " ^ 
    "          (Try (Repeat (Rewrite_Set expand_binoms    False))) @@  " ^ 
    "          (Try (Repeat (Rewrite_Set_Inst [(bdv,v_v::real)]         " ^
    "                                 make_ratpoly_in     False))) @@  " ^
    "          (Try (Repeat (Rewrite_Set polyeq_simplify  False)))) e_e " ^
    " in (SubProblem (PolyEq',[polynomial,univariate,equation], [no_met])   " ^
    "                 [BOOL e_e, REAL v_v]))"
   ));

*}
ML{*
store_met
 (prep_met thy "met_polyeq_d0" [] e_metID
 (["PolyEq","solve_d0_polyeq_equation"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 0"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",
    rls'=PolyEq_erls,
    srls=e_rls,
    prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Solve_d0_polyeq_equation  (e_e::bool) (v_v::real)  = " ^
    "(let e_e =  ((Try (Rewrite_Set_Inst [(bdv,v_v::real)]      " ^
    "                  d0_polyeq_simplify  False))) e_e        " ^
    " in ((Or_to_List e_e)::bool list))"
 ));
*}
ML{*
store_met
 (prep_met thy "met_polyeq_d1" [] e_metID
 (["PolyEq","solve_d1_polyeq_equation"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 1"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI", rls'=PolyEq_erls, srls=e_rls, prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Solve_d1_polyeq_equation  (e_e::bool) (v_v::real)  =   " ^
    "(let e_e =  ((Try (Rewrite_Set_Inst [(bdv,v_v::real)]        " ^
    "                  d1_polyeq_simplify   True))          @@  " ^
    "            (Try (Rewrite_Set polyeq_simplify  False)) @@  " ^
    "            (Try (Rewrite_Set norm_Rational_parenthesized False))) e_e;" ^
    " (L_L::bool list) = ((Or_to_List e_e)::bool list)            " ^
    " in Check_elementwise L_LL {(v_v::real). Assumptions} )"
 ));
*}
ML{*
store_met
 (prep_met thy "met_polyeq_d22" [] e_metID
 (["PolyEq","solve_d2_polyeq_equation"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 2"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",
    rls'=PolyEq_erls,
    srls=e_rls,
    prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Solve_d2_polyeq_equation  (e_e::bool) (v_v::real) =      " ^
    "  (let e_e = ((Try (Rewrite_Set_Inst [(bdv,v_v::real)]         " ^
    "                    d2_polyeq_simplify           True)) @@   " ^
    "             (Try (Rewrite_Set polyeq_simplify   False)) @@  " ^
    "             (Try (Rewrite_Set_Inst [(bdv,v_v::real)]         " ^
    "                    d1_polyeq_simplify            True)) @@  " ^
    "            (Try (Rewrite_Set polyeq_simplify    False)) @@  " ^
    "            (Try (Rewrite_Set norm_Rational_parenthesized False))) e_e;" ^
    " (L_L::bool list) = ((Or_to_List e_e)::bool list)              " ^
    " in Check_elementwise L_LL {(v_v::real). Assumptions} )"
 ));
*}
ML{*
store_met
 (prep_met thy "met_polyeq_d2_bdvonly" [] e_metID
 (["PolyEq","solve_d2_polyeq_bdvonly_equation"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 2"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",
    rls'=PolyEq_erls,
    srls=e_rls,
    prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Solve_d2_polyeq_bdvonly_equation  (e_e::bool) (v_v::real) =" ^
    "  (let e_e = ((Try (Rewrite_Set_Inst [(bdv,v_v::real)]         " ^
    "                   d2_polyeq_bdv_only_simplify    True)) @@  " ^
    "             (Try (Rewrite_Set polyeq_simplify   False)) @@  " ^
    "             (Try (Rewrite_Set_Inst [(bdv,v_v::real)]         " ^
    "                   d1_polyeq_simplify             True)) @@  " ^
    "            (Try (Rewrite_Set polyeq_simplify    False)) @@  " ^
    "            (Try (Rewrite_Set norm_Rational_parenthesized False))) e_e;" ^
    " (L_L::bool list) = ((Or_to_List e_e)::bool list)              " ^
    " in Check_elementwise L_LL {(v_v::real). Assumptions} )"
 ));
*}
ML{*
store_met
 (prep_met thy "met_polyeq_d2_sqonly" [] e_metID
 (["PolyEq","solve_d2_polyeq_sqonly_equation"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 2"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",
    rls'=PolyEq_erls,
    srls=e_rls,
    prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Solve_d2_polyeq_sqonly_equation  (e_e::bool) (v_v::real) =" ^
    "  (let e_e = ((Try (Rewrite_Set_Inst [(bdv,v_v::real)]          " ^
    "                   d2_polyeq_sq_only_simplify     True)) @@   " ^
    "            (Try (Rewrite_Set polyeq_simplify    False)) @@   " ^
    "            (Try (Rewrite_Set norm_Rational_parenthesized False))) e_e; " ^
    " (L_L::bool list) = ((Or_to_List e_e)::bool list)               " ^
    " in Check_elementwise L_LL {(v_v::real). Assumptions} )"
 ));
*}
ML{*
store_met
 (prep_met thy "met_polyeq_d2_pq" [] e_metID
 (["PolyEq","solve_d2_polyeq_pq_equation"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 2"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",
    rls'=PolyEq_erls,
    srls=e_rls,
    prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Solve_d2_polyeq_pq_equation  (e_e::bool) (v_v::real) =   " ^
    "  (let e_e = ((Try (Rewrite_Set_Inst [(bdv,v_v::real)]         " ^
    "                   d2_polyeq_pqFormula_simplify   True)) @@  " ^
    "            (Try (Rewrite_Set polyeq_simplify    False)) @@  " ^
    "            (Try (Rewrite_Set norm_Rational_parenthesized False))) e_e;" ^
    " (L_L::bool list) = ((Or_to_List e_e)::bool list)              " ^
    " in Check_elementwise L_LL {(v_v::real). Assumptions} )"
 ));
*}
ML{*
store_met
 (prep_met thy "met_polyeq_d2_abc" [] e_metID
 (["PolyEq","solve_d2_polyeq_abc_equation"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 2"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",
    rls'=PolyEq_erls,
    srls=e_rls,
    prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Solve_d2_polyeq_abc_equation  (e_e::bool) (v_v::real) =   " ^
    "  (let e_e = ((Try (Rewrite_Set_Inst [(bdv,v_v::real)]          " ^
    "                   d2_polyeq_abcFormula_simplify   True)) @@  " ^
    "            (Try (Rewrite_Set polyeq_simplify     False)) @@  " ^
    "            (Try (Rewrite_Set norm_Rational_parenthesized False))) e_e;" ^
    " (L_L::bool list) = ((Or_to_List e_e)::bool list)               " ^
    " in Check_elementwise L_LL {(v_v::real). Assumptions} )"
 ));
*}
ML{*
store_met
 (prep_met thy "met_polyeq_d3" [] e_metID
 (["PolyEq","solve_d3_polyeq_equation"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["(lhs e_e) is_poly_in v_v ",
	       "((lhs e_e) has_degree_in v_v) = 3"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",
    rls'=PolyEq_erls,
    srls=e_rls,
    prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Solve_d3_polyeq_equation  (e_e::bool) (v_v::real) =     " ^
    "  (let e_e = ((Try (Rewrite_Set_Inst [(bdv,v_v::real)]        " ^
    "                    d3_polyeq_simplify           True)) @@  " ^
    "             (Try (Rewrite_Set polyeq_simplify  False)) @@  " ^
    "             (Try (Rewrite_Set_Inst [(bdv,v_v::real)]        " ^
    "                    d2_polyeq_simplify           True)) @@  " ^
    "             (Try (Rewrite_Set polyeq_simplify  False)) @@  " ^
    "             (Try (Rewrite_Set_Inst [(bdv,v_v::real)]        " ^   
    "                    d1_polyeq_simplify           True)) @@  " ^
    "             (Try (Rewrite_Set polyeq_simplify  False)) @@  " ^
    "             (Try (Rewrite_Set norm_Rational_parenthesized False))) e_e;" ^
    " (L_L::bool list) = ((Or_to_List e_e)::bool list)             " ^
    " in Check_elementwise L_LL {(v_v::real). Assumptions} )"
   ));
*}
ML{*
 (*.solves all expanded (ie. normalized) terms of degree 2.*) 
 (*Oct.02 restriction: 'eval_true 0 =< discriminant' ony for integer values
   by 'PolyEq_erls'; restricted until Float.thy is implemented*)
store_met
 (prep_met thy "met_polyeq_complsq" [] e_metID
 (["PolyEq","complete_square"],
   [("#Given" ,["equality e_e","solveFor v_v"]),
   ("#Where" ,["matches (?a = 0) e_e", 
	       "((lhs e_e) has_degree_in v_v) = 2"]),
   ("#Find"  ,["solutions v_v'i'"])
  ],
   {rew_ord'="termlessI",rls'=PolyEq_erls,srls=e_rls,prls=PolyEq_prls,
    calc=[("sqrt", ("NthRoot.sqrt", eval_sqrt "#sqrt_"))],
    crls=PolyEq_crls, nrls=norm_Rational},
   "Script Complete_square (e_e::bool) (v_v::real) =                         " ^
   "(let e_e = " ^ 
   "    ((Try (Rewrite_Set_Inst [(bdv,v_v)] cancel_leading_coeff True)) " ^
   "        @@ (Try (Rewrite_Set_Inst [(bdv,v_v)] complete_square True))     " ^
   "        @@ (Try (Rewrite square_explicit1 False))                       " ^
   "        @@ (Try (Rewrite square_explicit2 False))                       " ^
   "        @@ (Rewrite root_plus_minus True)                               " ^
   "        @@ (Try (Repeat (Rewrite_Inst [(bdv,v_v)] bdv_explicit1 False))) " ^
   "        @@ (Try (Repeat (Rewrite_Inst [(bdv,v_v)] bdv_explicit2 False))) " ^
   "        @@ (Try (Repeat                                                 " ^
   "                  (Rewrite_Inst [(bdv,v_v)] bdv_explicit3 False)))       " ^
   "        @@ (Try (Rewrite_Set calculate_RootRat False))                  " ^
   "        @@ (Try (Repeat (Calculate SQRT)))) e_e                         " ^
   " in ((Or_to_List e_e)::bool list))"
   ));
*}
ML{*

(* termorder hacked by MG *)
local (*. for make_polynomial_in .*)

open Term;  (* for type order = EQUAL | LESS | GREATER *)

fun pr_ord EQUAL = "EQUAL"
  | pr_ord LESS  = "LESS"
  | pr_ord GREATER = "GREATER";

fun dest_hd' x (Const (a, T)) = (((a, 0), T), 0)
  | dest_hd' x (t as Free (a, T)) =
    if x = t then ((("|||||||||||||", 0), T), 0)                        (*WN*)
    else (((a, 0), T), 1)
  | dest_hd' x (Var v) = (v, 2)
  | dest_hd' x (Bound i) = ((("", i), dummyT), 3)
  | dest_hd' x (Abs (_, T, _)) = ((("", 0), T), 4);

fun size_of_term' x (Const ("Atools.pow",_) $ Free (var,_) $ Free (pot,_)) =
    (case x of                                                          (*WN*)
	    (Free (xstr,_)) => 
		(if xstr = var then 1000*(the (int_of_str pot)) else 3)
	  | _ => raise error ("size_of_term' called with subst = "^
			      (term2str x)))
  | size_of_term' x (Free (subst,_)) =
    (case x of
	    (Free (xstr,_)) => (if xstr = subst then 1000 else 1)
	  | _ => raise error ("size_of_term' called with subst = "^
			  (term2str x)))
  | size_of_term' x (Abs (_,_,body)) = 1 + size_of_term' x body
  | size_of_term' x (f$t) = size_of_term' x f  +  size_of_term' x t
  | size_of_term' x _ = 1;


fun term_ord' x pr thy (Abs (_, T, t), Abs(_, U, u)) =       (* ~ term.ML *)
      (case term_ord' x pr thy (t, u) of EQUAL => Term_Ord.typ_ord (T, U) | ord => ord)
  | term_ord' x pr thy (t, u) =
      (if pr then 
	 let
	   val (f, ts) = strip_comb t and (g, us) = strip_comb u;
	   val _=writeln("t= f@ts= \""^
	      ((Syntax.string_of_term (thy2ctxt thy)) f)^"\" @ \"["^
	      (commas(map (Syntax.string_of_term (thy2ctxt thy)) ts))^"]\"");
	   val _=writeln("u= g@us= \""^
	      ((Syntax.string_of_term (thy2ctxt thy)) g)^"\" @ \"["^
	      (commas(map (Syntax.string_of_term (thy2ctxt thy)) us))^"]\"");
	   val _=writeln("size_of_term(t,u)= ("^
	      (string_of_int(size_of_term' x t))^", "^
	      (string_of_int(size_of_term' x u))^")");
	   val _=writeln("hd_ord(f,g)      = "^((pr_ord o (hd_ord x))(f,g)));
	   val _=writeln("terms_ord(ts,us) = "^
			   ((pr_ord o (terms_ord x) str false)(ts, us)));
	   val _=writeln("-------");
	 in () end
       else ();
	 case int_ord (size_of_term' x t, size_of_term' x u) of
	   EQUAL =>
	     let val (f, ts) = strip_comb t and (g, us) = strip_comb u in
	       (case hd_ord x (f, g) of EQUAL => (terms_ord x str pr) (ts, us) 
	     | ord => ord)
	     end
	 | ord => ord)
and hd_ord x (f, g) =                                        (* ~ term.ML *)
  prod_ord (prod_ord Term_Ord.indexname_ord Term_Ord.typ_ord) 
            int_ord (dest_hd' x f, dest_hd' x g)
and terms_ord x str pr (ts, us) = 
    list_ord (term_ord' x pr (assoc_thy "Isac"))(ts, us);
in

fun ord_make_polynomial_in (pr:bool) thy subst tu = 
    let
	(* val _=writeln("*** subs variable is: "^(subst2str subst)); *)
    in
	case subst of
	    (_,x)::_ => (term_ord' x pr thy tu = LESS)
	  | _ => raise error ("ord_make_polynomial_in called with subst = "^
			  (subst2str subst))
    end;
end;(*local*)

*}
ML{*
val order_add_mult_in = prep_rls(
  Rls{id = "order_add_mult_in", preconds = [], 
      rew_ord = ("ord_make_polynomial_in",
		 ord_make_polynomial_in false (theory "Poly")),
      erls = e_rls,srls = Erls,
      calc = [],
      (*asm_thm = [],*)
      rules = [Thm ("real_mult_commute",num_str @{thm real_mult_commute}),
	       (* z * w = w * z *)
	       Thm ("real_mult_left_commute",num_str @{thm real_mult_left_commute}),
	       (*z1.0 * (z2.0 * z3.0) = z2.0 * (z1.0 * z3.0)*)
	       Thm ("real_mult_assoc",num_str @{thm real_mult_assoc}),		
	       (*z1.0 * z2.0 * z3.0 = z1.0 * (z2.0 * z3.0)*)
	       Thm ("add_commute",num_str @{thm add_commute}),	
	       (*z + w = w + z*)
	       Thm ("add_left_commute",num_str @{thm add_left_commute}),
	       (*x + (y + z) = y + (x + z)*)
	       Thm ("add_assoc",num_str @{thm add_assoc})	               
	       (*z1.0 + z2.0 + z3.0 = z1.0 + (z2.0 + z3.0)*)
	       ], scr = EmptyScr}:rls);

*}
ML{*
val collect_bdv = prep_rls(
  Rls{id = "collect_bdv", preconds = [], 
      rew_ord = ("dummy_ord", dummy_ord),
      erls = e_rls,srls = Erls,
      calc = [],
      (*asm_thm = [],*)
      rules = [Thm ("bdv_collect_1",num_str @{thm bdv_collect_1}),
	       Thm ("bdv_collect_2",num_str @{thm bdv_collect_2}),
	       Thm ("bdv_collect_3",num_str @{thm bdv_collect_3}),

	       Thm ("bdv_collect_assoc1_1",num_str @{thm bdv_collect_assoc1_1}),
	       Thm ("bdv_collect_assoc1_2",num_str @{thm bdv_collect_assoc1_2}),
	       Thm ("bdv_collect_assoc1_3",num_str @{thm bdv_collect_assoc1_3}),

	       Thm ("bdv_collect_assoc2_1",num_str @{thm bdv_collect_assoc2_1}),
	       Thm ("bdv_collect_assoc2_2",num_str @{thm bdv_collect_assoc2_2}),
	       Thm ("bdv_collect_assoc2_3",num_str @{thm bdv_collect_assoc2_3}),


	       Thm ("bdv_n_collect_1",num_str @{thm bdv_n_collect_1}),
	       Thm ("bdv_n_collect_2",num_str @{thm bdv_n_collect_2}),
	       Thm ("bdv_n_collect_3",num_str @{thm bdv_n_collect_3}),

	       Thm ("bdv_n_collect_assoc1_1",num_str @{thm bdv_n_collect_assoc1_1}),
	       Thm ("bdv_n_collect_assoc1_2",num_str @{thm bdv_n_collect_assoc1_2}),
	       Thm ("bdv_n_collect_assoc1_3",num_str @{thm bdv_n_collect_assoc1_3}),

	       Thm ("bdv_n_collect_assoc2_1",num_str @{thm bdv_n_collect_assoc2_1}),
	       Thm ("bdv_n_collect_assoc2_2",num_str @{thm bdv_n_collect_assoc2_2}),
	       Thm ("bdv_n_collect_assoc2_3",num_str @{thm bdv_n_collect_assoc2_3})
	       ], scr = EmptyScr}:rls);

*}
ML{*
(*.transforms an arbitrary term without roots to a polynomial [4] 
   according to knowledge/Poly.sml.*) 
val make_polynomial_in = prep_rls(
  Seq {id = "make_polynomial_in", preconds = []:term list, 
       rew_ord = ("dummy_ord", dummy_ord),
      erls = Atools_erls, srls = Erls,
      calc = [], (*asm_thm = [],*)
      rules = [Rls_ expand_poly,
	       Rls_ order_add_mult_in,
	       Rls_ simplify_power,
	       Rls_ collect_numerals,
	       Rls_ reduce_012,
	       Thm ("realpow_oneI",num_str @{thm realpow_oneI}),
	       Rls_ discard_parentheses,
	       Rls_ collect_bdv
	       ],
      scr = EmptyScr
      }:rls);     

*}
ML{*
val separate_bdvs = 
    append_rls "separate_bdvs"
	       collect_bdv
	       [Thm ("separate_bdv", num_str @{thm separate_bdv}),
		(*"?a * ?bdv / ?b = ?a / ?b * ?bdv"*)
		Thm ("separate_bdv_n", num_str @{thm separate_bdv_n}),
		Thm ("separate_1_bdv", num_str @{thm separate_1_bdv}),
		(*"?bdv / ?b = (1 / ?b) * ?bdv"*)
		Thm ("separate_1_bdv_n", num_str @{thm separate_1_bdv_n}),
		(*"?bdv ^^^ ?n / ?b = 1 / ?b * ?bdv ^^^ ?n"*)
		Thm ("add_divide_distrib", 
		     num_str @{thm add_divide_distrib})
		(*"(?x + ?y) / ?z = ?x / ?z + ?y / ?z"
		      WN051031 DOES NOT BELONG TO HERE*)
		];
*}
ML{*
val make_ratpoly_in = prep_rls(
  Seq {id = "make_ratpoly_in", preconds = []:term list, 
       rew_ord = ("dummy_ord", dummy_ord),
      erls = Atools_erls, srls = Erls,
      calc = [], (*asm_thm = [],*)
      rules = [Rls_ norm_Rational,
	       Rls_ order_add_mult_in,
	       Rls_ discard_parentheses,
	       Rls_ separate_bdvs,
	       (* Rls_ rearrange_assoc, WN060916 why does cancel_p not work?*)
	       Rls_ cancel_p
	       (*Calc ("HOL.divide"  ,eval_cancel "#divide_e") too weak!*)
	       ],
      scr = EmptyScr}:rls);      


ruleset' := overwritelthy @{theory} (!ruleset',
  [("order_add_mult_in", order_add_mult_in),
   ("collect_bdv", collect_bdv),
   ("make_polynomial_in", make_polynomial_in),
   ("make_ratpoly_in", make_ratpoly_in),
   ("separate_bdvs", separate_bdvs)
   ]);
*}

end






